;##
;# Support functions for windows based icons
;# Mostly copied from winico.tcl part of winico package
;#
set [file root [file tail [info script]]]_History {
   $Header: /cvsroot/snackamp/snackamp/lib/IconSupport.tcl,v 1.8 2002/10/14 14:32:42 wilkason Exp $
}
if {[catch {package require Winico} result]} {
   puts "No built-in or available Winco, using local DLL"
   load [file join [file dirname [info script]] myWinico winico03.dll]
}
;##
;# Routines below are in the winico distribution but not in the version
;# included in freewrap. So they are included here.
;#
proc winico_seticon { w icofile } {
   set icofile [winico_file $icofile]   ;# calls either wrapped or stub file
   set ico [winico create $icofile]
   set screendepth [winfo screendepth .]
   set bigsize "32x32"
   set bigpos -1
   set bigdepth 0
   set smallsize "16x16"
   set smallpos -1
   set smalldepth 0
   foreach i [winico info $ico] {
      array set opts $i
      set depth    $opts(-bpp)
      set pos      $opts(-pos)
      set geometry $opts(-geometry)
      if { $geometry=="$bigsize" && $depth<=$screendepth } {
         if { $depth>$bigdepth } {
            set bigpos $pos
            set bigdepth $depth
         }
      } elseif { $geometry=="$smallsize" && $depth<=$screendepth } {
         if { $depth>$smalldepth } {
            set smallpos $pos
            set smalldepth $depth
         }
      }
   }
   if { $bigpos==-1 && $smallpos==-1 } {
      puts stderr "couldn't find $bigsize and $smallsize icons in $icofile"
      return $ico
   } elseif { $bigpos==-1 } {
      set bigpos $smallpos
      puts stderr "couldn't find $bigsize icons in $icofile"
   } elseif { $smallpos==-1 } {
      set smallpos $bigpos
      puts stderr "couldn't find $smallsize icons in $icofile"
   }
   # puts stderr "big icon is $bigsize,bpp:$bigdepth,pos:$bigpos"
   # puts stderr "small icon is $smallsize,bpp:$smalldepth,pos:$smallpos"
   winico setwindow $w $ico big   $bigpos
   winico setwindow $w $ico small $smallpos
   return $ico
}
proc winico_delall {} {
   foreach i [winico info] { winico delete $i }
}
proc winico_loadicon { w symbol } {
   set ico [winico load $symbol]
   winico setwindow $w $ico big
   winico setwindow $w $ico small
}
###############################################################################
# Function   : iconSupport
# Description: Add icons in taskbar for Windows
# Author     : Tom Wilkason
# Date       : 1/9/2001
###############################################################################
proc iconSupport {args} {
   global TA
   if {[catch {
      set TA(IconFile) [file join icons snackAmp.ico]
      update
      saLog "Installing icons"
      set Icon [winico_seticon $::SA $TA(IconFile)]
      set TA(Icon) $Icon
      winico text $Icon {Snack Music File Player, LMB to pause, RMB for miniPlayer}
      winico taskbar add $Icon -callback "package require miniPlayer;iconCallback %m $Icon %x %y"
   } result]} {
      saLog $result
   }
}

package provide IconSupport 1.0


